package com.javafanatics;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.function.Executable;


import static org.junit.jupiter.api.Assertions.*;

class ActivityCalculatorTest {

    @Test
    void should_ReturnBad_When_AgeBelow20(){
        //given
        int weeklyCardioMinutes = 40;
        int weeklyWorkouts = 1;

        //when
        String actual = ActivityCalculator.rateActivityLevel(weeklyCardioMinutes, weeklyWorkouts);

        //then
        assertEquals("bad", actual);
    }

    @Test
    void should_ReturnAverage_When_AgeBetween20and40(){
        //given
        int weeklyCardioMinutes = 40;
        int weeklyWorkouts = 3;

        //when
        String actual = ActivityCalculator.rateActivityLevel(weeklyCardioMinutes, weeklyWorkouts);

        //then
        assertEquals("average", actual);

    }

    @Test
    void should_ReturnGood_When_AgeAbove40(){
        //given
        int weeklyCardioMinutes = 40;
        int weeklyWorkouts = 7;

        //when
        String actual = ActivityCalculator.rateActivityLevel(weeklyCardioMinutes, weeklyWorkouts);

        //then
        assertEquals("good", actual);

    }

    @Test
    void should_ThrowException_When_InputBelowZero(){
        //given
        int weeklyCardioMinutes = -40;
        int weeklyWorkouts = 7;

        //when
        Executable executable = () -> ActivityCalculator.rateActivityLevel(weeklyCardioMinutes, weeklyWorkouts);


        //then
        assertThrows(RuntimeException.class, executable);

    }




}